-- AUTHOR: CENNYCOAST (ELI)
-- SPECIAL THANKS TO JIFFY UP FOR PARTS OF THIS CODE

function init()
    RegisterTool("containerweapons", "Container Weapon", "MOD/vox/containertool.vox", 2)
    SetBool("game.tool.containerweapons.enabled", true)
    SetFloat("game.tool.containerweapons.ammo", 10000)
    containerhFallSound = LoadSound("MOD/sound/containerhFallSound.ogg")
    random_n = 0
    power = 0
    power2 = 0
    containerh_rain_cooldown = 1
    SetBool("level.explode", false)
    SoundON = LoadSound("MOD/sound/ClickerA.ogg")
    SoundOFF = LoadSound("MOD/sound/ClickerC.ogg")
    SoundBool = 0

    playedLoop1 = false
    playedLoop2 = false

    FirstCharge = LoadSound("MOD/assets/first-charge.ogg")
    FirstHiss = LoadLoop("MOD/assets/first-hiss.ogg")
    SecondCharge = LoadSound("MOD/assets/second-charge.ogg")
    SecondHiss = LoadLoop("MOD/assets/second-hiss.ogg")
    --DebugPrint("init")
    --DebugPrint("loaded instance")
    SetInt("level.currentcontcount", 0)

    containers = {"random","MOD/cont2.xml", "MOD/cont1.xml"}

    
    containersrand = {"MOD/cont2.xml", "MOD/cont4.xml", "MOD/cont5.xml", "MOD/cont6.xml", "MOD/cont7.xml"}

    if HasKey("savegame.mod.currentContainer") == false then
        SetInt("savegame.mod.currentContainer", 1)
    end

    if GetInt("savegame.mod.currentContainer") == 1 then
        containermode = "random"
    else 
        containermode = "single"
     end


end

function containerh_Fall()


    if InputPressed("q") and GetBool("level.explode") == true and SoundBool == 1 then
        PlaySound(SoundON, GetPlayerTransform().pos, 1)
        SoundBool = 0
        SetBool("level.explode", false)
    else
        if InputPressed("q") and GetBool("level.explode") == false and SoundBool == 0 then
            PlaySound(SoundOFF, GetPlayerTransform().pos, 1)
            SoundBool = 1
            SetBool("level.explode", true)
        end
    end



    if InputDown("lmb") and power < 2.5 then
        power = power + 0.02
    end
    if InputDown("lmb") then
        if power > 1 then
            if playedLoop2 == false then
                PlaySound(SecondCharge)
                playedLoop2 = true
            end
            PlayLoop(SecondHiss)
        else
            if playedLoop1 == false then
                PlaySound(FirstCharge)
                playedLoop1 = true
            end
            PlayLoop(FirstHiss)
        end
    end

    local offset = Transform(Vec(0.2, -0.1, -0.3), QuatEuler(0, 0, 0))
    SetToolTransform(offset)
    local camera = GetCameraTransform()

    if InputDown("lmb") then
        local random_n = math.random(-12, 12)
        local aim_pos = TransformToParentPoint(camera, Vec(0, 0, -7))
        local hit, dist, normal = QueryRaycast(camera.pos, VecNormalize(VecSub(aim_pos, camera.pos)), 220, 0, false)
        start_pos = TransformToParentPoint(camera, Vec(random_n, 16, -12))
        direction1 = VecSub(goal_Pos, start_pos)
        direction1 = VecScale(direction1, power)
        goal_Pos = TransformToParentPoint(camera, Vec(0, 0, -dist))
    end

	if InputPressed("leftarrow") then

		current_int = GetInt("savegame.mod.currentContainer")
		if current_int < 2 then
			current_int = 3			
		else 
			current_int = current_int - 1
		end


		if current_int == 1 then
			containermode = "random"
		else 
			containermode = "single"
		end
		SetInt("savegame.mod.currentContainer", current_int)
	end



	if InputPressed("rightarrow") then

		current_int = GetInt("savegame.mod.currentContainer")
		if current_int > 2 then
			current_int = 1
		else 
			current_int = current_int + 1
		end

		if current_int == 1 then
			containermode = "random"
		else 
			containermode = "single"
		end
		SetInt("savegame.mod.currentContainer", current_int)
	end


    if InputDown("lmb") and InputDown("rmb") then
        local RandomPos = Vec(math.random(-45, 45), math.random(-45, 45), math.random(-45, 45))

        local RandomcontainerhPos = VecAdd(goal_Pos, RandomPos)
        power = 1.8
        containerh_rain_cooldown = containerh_rain_cooldown + 1

        if containerh_rain_cooldown == 5 then
			if containermode == "random" then
				containerh =
					Spawn(
					containersrand[math.random(1, #containersrand)],
					Transform(start_pos, QuatLookAt(goal_Pos, RandomcontainerhPos))
				)
			else
				containerh =
					Spawn(
					containers[GetInt("savegame.mod.currentContainer")],
					Transform(start_pos, QuatLookAt(goal_Pos, RandomcontainerhPos))
				)
			end
	
            for i, body in ipairs(containerh) do
                SetBodyVelocity(body, direction1)
            end

            containerh_rain_cooldown = 1
        end
    end

    if InputReleased("lmb") and not InputDown("rmb") then
        playedLoop1 = false
        playedLoop2 = false
        local RandomPos = Vec(math.random(-15, 15), math.random(-15, 15), math.random(-15, 15))
        local RandomcontainerhPos = VecAdd(goal_Pos, RandomPos)

        if containermode == "random" then
            containerh =
                Spawn(
                containersrand[math.random(1, #containersrand)],
                Transform(start_pos, QuatLookAt(goal_Pos, RandomcontainerhPos))
            )
        else
            containerh =
                Spawn(
                containers[GetInt("savegame.mod.currentContainer")],
                Transform(start_pos, QuatLookAt(goal_Pos, RandomcontainerhPos))
            )
        end

        for i, body in ipairs(containerh) do
            SetBodyVelocity(body, direction1)
        end

        power = 0
        PlaySound(containerhFallSound, start_pos, 0.5)
    end


    if InputPressed("mmb") then
        local aim_pos = TransformToParentPoint(camera, Vec(0, 0, -7))
        local hit, dist, normal = QueryRaycast(camera.pos, VecNormalize(VecSub(aim_pos, camera.pos)), 220, 0, true)
        local start_pos = TransformToParentPoint(camera, Vec(0, 0, -12))
        local direction1 = VecSub(goal_Pos, start_pos)
        local direction1 = VecScale(direction1, power)
        local goal_Pos = TransformToParentPoint(camera, Vec(0, 0, -dist))

        if containermode == "random" then
            containerh =
                Spawn(
                containersrand[math.random(1, #containersrand)],
                Transform(start_pos, QuatLookAt(goal_Pos, RandomcontainerhPos))
            )
        else
            containerh =
                Spawn(
                containers[GetInt("savegame.mod.currentContainer")],
                Transform(start_pos, QuatLookAt(goal_Pos, RandomcontainerhPos))
            )
        end

    end
end

function randN(lower, upper)
    return math.random(lower, upper)
end

function draw()

    if GetString("game.player.tool") == "containerweapons" and GetPlayerVehicle() == 0 then
        UiPush()


        UiTranslate(40, 40)
        if
            GetString("game.player.tool") == "containerweapons" and GetPlayerVehicle() == 0 and
                GetBool("game.player.canusetool")
         then
            if InputDown("lmb") then
                UiTranslate(randN(0 - power, power), randN(0 - power, power))
                UiRotate(randN(0 - power, power))
            end
        end
        UiAlign("left top")
        UiImageBox("MOD/assets/pressure-bar.png", 60, 300, 10, 10)
        UiTranslate(0, 0)
        UiImageBox("MOD/assets/fill-bar.png", 60, 300 - power * 110, 10, 10)
        if power > 1.7 then
            UiAlign("center top")
            UiTranslate(30, -20)
            UiImageBox("MOD/assets/warning.png", 65, 65, 0, 0)
        end

        UiPop()

        local info = {}
		info[#info + 1] = {"Arrows", "Change Container"}
        info[#info + 1] = {"Hold LMB", "Container Missile"}
        info[#info + 1] = {"LMB + RMB", "Container Rain"}
        info[#info + 1] = {"MMB", "Container Spawn"}

        if GetBool("level.explode") == true then
            info[#info + 1] = {"Q", "Explode ON"}
        else
            if GetBool("level.explode") == false then
                info[#info + 1] = {"Q", "Explode OFF"}
            end
        end
		

        UiPush()
        UiAlign("top left")
        local w = 200
        local h = #info * 22 + 30 + 90
        UiTranslate(40, UiHeight() - h - 20)
        --UiColor(0,0,0,0.5)
        UiImageBox("MOD/assets/box-10.png", 340, h, 10, 10)
		UiTranslate(20,20)
		
		UiImageBox("MOD/assets/random.png", 86, 30, 10, 10)
		if GetInt("savegame.mod.currentContainer") == 1 then

		else 
			UiColor(0,0,0,0.5)
			UiRect(86,30)
			UiColor(1,1,1,1)
		end
		if GetInt("savegame.mod.currentContainer") == 1 then
		UiTranslate(0,30)
		UiImageBox("MOD/assets/white.png", 86, 4, 0, 0)
		UiTranslate(0,-30)
		end
		
		UiTranslate(0,50)
			UiFont("MOD/assets/fonts/Montserrat-Bold.ttf", 15)
            UiAlign("left")
            UiText("Random")
		UiTranslate(0,-50)

		UiTranslate(106,0)
		UiImageBox("MOD/assets/blue.png", 86, 30, 10, 10)
		if GetInt("savegame.mod.currentContainer") == 2 then

		else 
			UiColor(0,0,0,0.5)
			UiRect(86,30)
			UiColor(1,1,1,1)
		end
		if GetInt("savegame.mod.currentContainer") == 2 then
			UiTranslate(0,30)
			UiImageBox("MOD/assets/white.png", 86, 4, 0, 0)
			UiTranslate(0,-30)
			end

			UiTranslate(0,50)
			UiFont("MOD/assets/fonts/Montserrat-Bold.ttf", 15)
            UiAlign("left")
            UiText("Blue")
		UiTranslate(0,-50)

		UiTranslate(106,0)
		UiImageBox("MOD/assets/crash.png", 86, 30, 10, 10)
		if GetInt("savegame.mod.currentContainer") == 3 then

		else 
			UiColor(0,0,0,0.5)
			UiRect(86,30)
			UiColor(1,1,1,1)
		end
		if GetInt("savegame.mod.currentContainer") == 3 then
			UiTranslate(0,30)
			UiImageBox("MOD/assets/white.png", 86, 4, 0, 0)
			UiTranslate(0,-30)
			end

			UiTranslate(0,50)
			UiFont("MOD/assets/fonts/Montserrat-Bold.ttf", 15)
            UiAlign("left")
            UiText("CrashCartel")

		UiTranslate(0,-50)
		UiAlign("center")
		UiTranslate(-245,50)
        UiTranslate(150, 32)
        UiColor(1, 1, 1)
        for i = 1, #info do
            local key = info[i][1]
            local func = info[i][2]
            UiFont("MOD/assets/fonts/Montserrat-Black.ttf", 22)
            UiAlign("right")
            UiText(key)
            UiTranslate(10, 0)
            UiFont("MOD/assets/fonts/Montserrat-Bold.ttf", 22)
            UiAlign("left")
            UiText(func)
            UiTranslate(-10, 22)
        end
        UiPop()
    end
end



function tick(dt)

    --DebugWatch("currentContStyle",GetInt("savegame.mod.currentContainer"))
    --DebugWatch("containerMode",containermode)

    if
        GetString("game.player.tool") == "containerweapons" and GetPlayerVehicle() == 0 and
            GetBool("game.player.canusetool")
     then
        containerh_Fall()

        if InputDown("lmb") then
            local offset = Transform(Vec(power * 0.005, power * 0.005, 0), QuatEuler(power * 0.95, -8, -12))
            SetToolTransform(offset)
        end
    end
end
